<template>
  <section row-editor :clob="keyEntry.options.clob">
    <section primary v-if="!keyEntry.options.fullscreen">
      <md-app-toolbar class="md-primary" md-elevation="0" toolbar>
        <md-button v-if="validationRequired && !validationReport" class="md-raised" @click="validate">Validate</md-button>
        <md-button v-else red class="md-raised"
                   :disabled="!changesToCommit || commitConflict || conflictingChange || (validationRequired && !validationPassed)"
                   @click="save(Infinity)">
          <span>Queue all | </span>
          <md-menu md-align-trigger md-dense md-direction="bottom-end" @click.stop.prevent="">
            <md-icon md-src="/img/md/arrow_drop_down.svg" md-menu-trigger/>

            <md-menu-content>
              <md-menu-item @click="save(0)">Queue only me</md-menu-item>
              <md-menu-item v-for="(keyEntry, i) in $store.state.editor.keyPath.slice(0, keyIndex)"
                            :key="i"
                            @click="save(i + 1)">Queue {{i + 1}} level{{i !== 0 ? "s" : ""}} down</md-menu-item>
            </md-menu-content>
          </md-menu>
        </md-button>
        <md-button :disabled="!changesToCommit" @click="discard">Discard</md-button>
        <span flex></span>
        <md-menu md-align-trigger md-direction="bottom-end" md-dense>
          <md-button class="md-icon-button" md-menu-trigger :disabled="isReadMode"><md-icon md-src="/img/md/more_vert.svg"/></md-button>

          <md-menu-content class="md-dense">
            <md-menu-item :disabled="isReadMode || commitConflict || conflictingChange" @click="duplicateMode = true">Duplicate</md-menu-item>
            <md-menu-item>Decommision</md-menu-item>
          </md-menu-content>
        </md-menu>
      </md-app-toolbar>

      <duplicateEl :active="duplicateMode"
                   :modetable="modeTableName"
                   :currentmode="keyMode"
                   :keyentry="keyEntry"
                   @duplicate="onDuplicate"
                   @close="duplicateMode = false"/>

      <md-card error v-if="fetchError">
        <md-card-header>
          <p>An error occured while fetching this resource</p>
        </md-card-header>
        <!-- <p>{{fetchError.message}}</p> -->
        <md-card-actions>
          <md-button class="md-raised md-dense" @click="getRow">Retry</md-button>
        </md-card-actions>
      </md-card>

      <md-card warning v-if="conflictingChange">
        <md-card-header>
          <p>This table is locked</p>
        </md-card-header>
      </md-card>

      <md-card warning v-if="changesToCommit && commitConflict">
        <md-card-header>
          <p>You have pending changes that need to be committed before you can queue this change</p>
        </md-card-header>
        <md-card-actions>
          <md-button class="md-raised md-dense" @click="router.push('/changes')">See changes</md-button>
        </md-card-actions>
      </md-card>

      <md-card warning v-if="keyData.row && (keyData.row.VALID !== 'Y' || keyData.row.MODE_VALID !== 'Y')">
        <md-card-header>
          <p>This key is decommissioned</p>
          <p v-if="keyData.row.MODE_VALID !== 'Y'">All keys from this mode are decommissioned</p>
          <p v-else-if="keyData.row.VALID !== 'Y'">You can re-use this data by recommissioning a new key with a copy of this data</p>
        </md-card-header>
        <md-card-actions v-if="keyData.row.MODE_VALID === 'Y' && keyData.row.VALID !== 'Y'">
          <md-button class="md-raised md-dense">Recommission</md-button>
        </md-card-actions>
      </md-card>

      <md-card infobox v-if="keyData.validation === 'manual'">
        <md-card-header>
          <p>This table uses manual validation</p>
        </md-card-header>
      </md-card>

      <md-card infobox v-if="validationRequired && !validating && !validationReport">
        <md-card-header>
          <p><md-icon md-src="/img/md/check_circle_outline.svg"/>This table can be automatically validated</p>
        </md-card-header>
        <md-card-actions>
          <md-button class="md-dense" @click="validate">Validate now</md-button>
        </md-card-actions>
      </md-card>

      <md-card v-if="validating">
        <md-card-header>
          <p><img src="/img/hourglass_color.gif" alt="tick tock tick tock">Validating changes</p>
        </md-card-header>
      </md-card>

      <md-card success v-if="validationReport && validationReport.status === 'success'">
        <md-card-header>
          <p><md-icon md-src="/img/md/check_circle_outline.svg"/>Current changes are valid</p>
        </md-card-header>

        <md-card-actions>
          <md-button class="md-raised md-dense" :disabled="!changesToCommit || commitConflict || conflictingChange" @click="save(Infinity)">Queue all</md-button>
        </md-card-actions>
      </md-card>

      <md-card error v-if="validationReport && validationReport.status !== 'success'">
        <md-card-header>
          <p><md-icon md-src="/img/md/highlight_off.svg"/>Current changes are invalid</p>
        </md-card-header>
        <md-card-actions>
          <md-button class="md-raised md-dense" @click="validate">Try again</md-button>
          <md-button class="md-raised md-dense" :disabled="!changesToCommit" @click="discard">Discard</md-button>
        </md-card-actions>
      </md-card>

      <validationReportEl v-if="validationReport" :validationReport="validationReport"/>

      <img v-if="saving || (!fetchError && !keyData.row)" src="/img/hourglass_color.gif" alt="tick tock tick tock">

      <md-content summary class="md-elevation-1">
        <md-ripple>
          <p @click="expanded = !expanded" :edited="metaContentEdited"><span flex>{{summary}}</span><span>{{expanded ? 'hide' : 'show'}}</span><md-icon :md-src="expandIcon"/></p>
        </md-ripple>
        <transition name="meta-content">
          <section v-if="expanded">
            <template v-for="(renderEntry, i) in renderData.meta">
              <div v-if="Array.isArray(renderEntry)" :key="i" splitter>
                <rowEntry v-for="renderSubEntry in renderEntry"
                          :key="renderSubEntry.columnName"
                          :entry="renderSubEntry"
                          :pathIndex="keyIndex"
                          :keyData="keyData"
                          @follow="follow"/>
              </div>
              <rowEntry v-else :key="renderEntry.columnName"
                        :entry="renderEntry"
                        :pathIndex="keyIndex"
                        :keyData="keyData"
                        @follow="follow"/>
            </template>
          </section>
        </transition>
      </md-content>

      <template v-for="(renderEntry, i) in renderData.data">
        <div v-if="Array.isArray(renderEntry)" :key="i">
          <rowEntry v-for="renderSubEntry in renderEntry"
                    :key="renderSubEntry.columnName"
                    :entry="renderSubEntry"
                    :pathIndex="keyIndex"
                    :keyData="keyData"
                    @follow="follow"/>
        </div>
        <rowEntry v-else :key="renderEntry.columnName"
                  :entry="renderEntry"
                  :pathIndex="keyIndex"
                  :keyData="keyData"
                  @follow="follow"/>
      </template>
    </section>

    <clobEditor v-if="keyEntry.options.clob" :editorrow="editorRow" :keyEntry="keyEntry"/>
  </section>
</template>

<script lang='ts'>
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';
import { MdSwitch, MdCard } from 'vue-material/dist/components';
import { store } from '../../store';
import { KeyPathKey } from '../../store/editor';
import axios from '../../lib/axios';
import rowEntry from './rowEntry.vue';
import clobEditor from './clobEditor.vue';
import duplicateEl from './duplicate.vue';
import goStyle from '../../lib/to';
import eventBus, { KeySavedEvent } from '../../lib/eventBus';
import { modeColumns, ColumnType, invisibleColumns } from '../../lib/columnUtils';
import { edit } from 'brace';
import { notify, askInput } from '../app/alerting';
import router from '../../lib/router';
import validationReportEl, { ValidationReport, FailedValidationReport } from './validationReport.vue';

export interface CompiledRow {
  columnName: string;
  value: string;
  newValue: string;
  type: ColumnType;
  maxSize?: number; // for text inputs
  referencedTable?: string; // for keys
  table?: string; // to find other versions & trigger download of clobs
  key?: string; // to trigger downloads of clobs
  mode?: string; // to find other versions
}

type RenderSet = Array<CompiledRow | CompiledRow[]>;

Vue.use(MdSwitch);
Vue.use(MdCard);
@Component({
  components: {
    rowEntry,
    clobEditor,
    validationReportEl,
    duplicateEl,
  },
})
export default class extends Vue {

  @Prop()
  private keyEntry!: KeyPathKey;

  @Prop(Number)
  private keyIndex!: number;

  private keyData: any = {};
  private renderData?: {
    meta: RenderSet;
    data: RenderSet;
  } = {meta: [], data: []};

  private expanded = false;
  private fetchError: Error | null = null;
  private saving = false;

  private validating = false;
  private validationReport: ValidationReport | FailedValidationReport | null = null;

  private duplicateMode = false;

  get metaContentEdited() {
    if (!this.renderData) {
      return false;
    }
    if (!this.renderData.meta) {
      return false;
    }
    for (const renderEntry of this.renderData.meta) {
      const subentries = Array.isArray(renderEntry) ? renderEntry : [renderEntry];
      for (const entry of subentries) {
        if (entry.newValue !== entry.value) {
          return true;
        }
      }
    }
    return false;
  }

  get validationRequired() {
    return this.keyEntry.tableName === 'L1_HLT_CONF';
  }

  get validationPassed() {
    return this.validationReport && this.validationReport.status === 'success';
  }

  get isReadMode() {
    return store.get.auth('isReadMode');
  }

  get changesToCommit(): boolean {
    return !this.saving && !this.isReadMode && this.numChanges !== 0;
  }

  get commitConflict(): boolean {
    if (!this.keyData) {
      return false;
    }
    const changes = store.get.database('mychanges');

    return changes.some(change => change.tableOwner !== this.keyData.owner);
  }

  get store() {
    return store;
  }

  get nextKey() {
    if (!this.keyIndex && this.keyIndex !== 0) {
      return null;
    } else {
      const nextIndex = this.keyIndex + 1;
      return store.state.editor.keyPath[nextIndex];
    }
  }

  get expandIcon(): string {
    if (this.expanded) {
      return '/img/md/arrow_up.svg';
    } else {
      return '/img/md/arrow_down.svg';
    }
  }

  get summary(): string {
    if (!this.keyData || !this.keyData.row) {
      return '';
    }
    const row = this.keyData.row;
    const modeColumn = this.keyData.mode_column;
    if (modeColumn && row[modeColumn] && row.VERSION) {
      return row[modeColumn] + ' - v' + row.VERSION;
    } else {
      return row.ID;
    }
  }

  get keyMode(): string {
    if (!this.keyData || !this.keyData.row || !this.keyData.mode_column) {
      return '';
    }
    return this.keyData.row[this.keyData.mode_column];
  }

  get editorRow(): CompiledRow | undefined {
    if (!this.keyEntry || !this.keyEntry.options.clob || !this.renderData) {
      return;
    }
    const editorRowName = this.keyEntry.options.clob;
    const reducer = (data: RenderSet) => data.reduce((r: CompiledRow[], d) => r.concat(d), []) as CompiledRow[];
    const allRows = this.allRenderRows();
    return allRows.find(r => r.columnName === editorRowName);
  }

  get numChanges(): number {
    const allRows = this.allRenderRows();
    return allRows.reduce((total, entry) => entry.newValue !== entry.value ? total + 1 : total, 0);
  }

  get router() {
    return router;
  }

  get conflictingChange(): boolean {
    const userData = store.state.auth.userData;
    if (!userData) {
      return false;
    }
    const username = userData.cern.fullname;
    const changes = store.state.database.changes;
    const otherChanges = Object.keys(changes).filter(name => name !== username)
                        .map(name => changes[name])
                        .reduce((t, m) => t.concat(m), []);
    return otherChanges.some(change => change.tableName === this.keyEntry.tableName);
  }

  get modeTableName(): string {
    if (!this.keyData || !this.keyData.metaData) {
      return '';
    }
    const r = this.keyData.metaData.find(o => o.name === this.keyData.mode_column);
    if (!r) {
      return '';
    }
    return r.FOREIGN_TABLE_NAME;
  }

  public async mounted() {
    eventBus.on('key-saved', this.onKeySaved);
    return this.getRow();
  }

  public beforeDestroy() {
    eventBus.off('key-saved', this.onKeySaved);
  }

  public updated() {
    if (this.keyEntry.options.clob) {
      const appScroller = document.querySelector('.md-app-scroller');
      if (appScroller) {
        appScroller.scrollLeft = 1e9;
      }
    }
  }

  public async getRow() {
    this.fetchError = null;
    this.keyData = {};
    if (this.keyEntry) {
      const {tableName, key} = this.keyEntry;
      const [dbResult, err] = await goStyle(store.dispatch.database('getRow', [tableName, key, 'nonblocking']));
      if (err) {
        return this.fetchError = err;
      }
      const data = dbResult.data;
      this.keyData = data;
      const entries: CompiledRow[] = data.metaData.map(column => {
        const result: CompiledRow = {
          columnName: column.name,
          value: data.row[column.name],
          newValue: data.row[column.name],
          type: this.getType(column, data),
        };
        if (column.data_length) {
          result.maxSize = Number(column.data_length);
        }
        if (result.type === 'key') {
          result.referencedTable = column.FOREIGN_TABLE_NAME;
        } else if (result.type === 'version') {
          result.table = tableName;
          result.mode = data.row[data.mode_column];
        } else if (result.type === 'clob') {
          result.table = tableName;
          result.key = key;
        }
        return result;
      });
      const renderData = {
        meta: [] as RenderSet,
        data: [] as RenderSet,
      };
      // some stuff we want on top, or together
      // filter them out first
      const getAndRemove = (n: string) => {
        const i = entries.findIndex(e => e.columnName === n);
        if (i !== -1) {
          const item = entries[i];
          entries.splice(i, 1);
          return item;
        }
      };
      const addIfPresent = <T>(dest: T[], ...items: Array<T | undefined>): T[] => {
        items.forEach(i => {
          if (i instanceof Array && i.length === 0) {
            return;
          } else if (i) {
            dest.push(i);
          }
        });
        return dest;
      };
      addIfPresent(renderData.meta, addIfPresent([], getAndRemove('ID'), getAndRemove('VERSION')));

      addIfPresent(renderData.meta,
        getAndRemove('AUTHOR'),
        getAndRemove('CREATION_DATE'),
        getAndRemove('CREATION_AUTHOR'),
        getAndRemove('DESCRIPTION'));

      // the rest we add to the relevant sections
      const metaColumns = ['ANCESTOR'];
      if (data.mode_column) {
        metaColumns.push(data.mode_column);
      }
      entries.filter(e => e.type !== 'invisible').forEach(entry => {
        const dest = metaColumns.includes(entry.columnName) ? 'meta' : 'data';
        renderData[dest].push(entry);
      });

      this.renderData = renderData;

    }
  }

  @Watch('numChanges')
  private numChangesChanged() {
    if (this.validationReport) {
      this.validationReport = null;
    }
  }

  private onKeySaved(event: KeySavedEvent) {
    const entry = this.allRenderRows().find(e => e.columnName !== 'ID' && e.newValue === event.oldKey);
    if (entry) {
      entry.newValue = event.newKey;
      if (event.autoQueueLevels && event.description) {
        const descriptionEntry = this.allRenderRows().find(e => e.columnName === 'DESCRIPTION');
        if (descriptionEntry) {
          descriptionEntry.newValue = event.description;
          if (event.tableOwner !== this.keyData.owner) {
            notify({
              type: 'warning',
              message: `unable to queue change for ${this.keyEntry.tableName}. There are pending conflicting changes.`,
            });
          } else if (this.validationRequired) {
            // we don't check this.validationPassed, onKeySaved always makes a change
            // that requires re-validation (entry.newValue points to new downstream key)
            notify({
              type: 'warning',
              message: `unable to queue change for ${this.keyEntry.tableName}. This data has not been validated`,
            });
          } else {
            this.save(event.autoQueueLevels - 1);
          }
        }
      }
    }
  }

  private getType(column, data): ColumnType {
    column.data_type = column.data_type || '';

    if (column.FOREIGN_TABLE_NAME) {
      return 'key';
    } else if (column.name === 'CREATION_DATE' || column.data_type.startsWith('TIMESTAMP')) {
      return 'date';
    } else if (column.name === 'VERSION') {
      return 'version';
    } else if (column.data_type === 'CLOB') {
      return 'clob';
    } else if (invisibleColumns.includes(column.name)) {
      return 'invisible';
    // can't change mode column
    } else if (modeColumns.concat('AUTHOR', data.mode_column).includes(column.name)) {
      return 'readonly';
    // automatic validation means readonly ID
    } else if (column.name === 'ID' && data.validation === 'automatic') {
      return 'readonly';
    } else {
      return 'text';
    }
  }

  private follow(row: CompiledRow, options: any = {}) {
    if (!row || !row.type) {
      return;
    } else if (row.type === 'clob') {
      options.clob = row.columnName;
      store.commit.editor('changeKeyPath', {position: this.keyIndex, entry: {options}});
    } else if (row.type === 'key') {
      store.commit.editor('changeKeyPath', {position: this.keyIndex, entry: {options: {}}});
      store.commit.editor('changeKeyPath', {position: this.keyIndex + 1, entry: {
        tableName: row.referencedTable as string,
        key: row.newValue,
        options,
      }});
    }
  }

  private allRenderRows(): CompiledRow[] {
    if (!this.renderData) {
      return [];
    }
    const reducer = (data: RenderSet) => data.reduce((r: CompiledRow[], d) => r.concat(d), []) as CompiledRow[];
    const allRows = reducer(this.renderData.data).concat(reducer(this.renderData.meta));
    return allRows;
  }

  private discard() {
    this.allRenderRows().forEach(entry => entry.newValue = entry.value);
  }

  private async save(autoQueueLevels = 0) {

    const ignoredColumnTypes: Array<CompiledRow['type']> = ['readonly', 'version', 'date', 'invisible'];
    const ignoredColumns = ['VALID', 'AUTHOR', 'CREATION_AUTHOR', 'CREATION_DATE', 'VERSION', 'ANCESTOR', 'MODE_VALID'];
    const entries = this.allRenderRows()
      .filter(entry => !ignoredColumnTypes.includes(entry.type))
      .filter(entry => !ignoredColumns.includes(entry.columnName));

    const descriptionEntry = entries.find(entry => entry.columnName === 'DESCRIPTION');
    const ensureNewDescription = () => {
      if (descriptionEntry && descriptionEntry.newValue === descriptionEntry.value) {
        return askInput({
          message: 'please provide a new description',
          default: descriptionEntry.newValue,
          maxlength: descriptionEntry.maxSize,
          cancelable: true,
        })
        .then(value => {
          if (!value) {
            return Promise.reject('no description given');
          } else {
            descriptionEntry.newValue = value;
            return ensureNewDescription();
          }
        });
      } else {
        return Promise.resolve();
      }
    };

    const [, descErr] = await goStyle(ensureNewDescription());
    if (descErr) {
      return;
    }
    this.saving = true;

    const oldKey = this.keyEntry.key;
    const body = {
      sourceKey: oldKey,
      row: {} as any,
    };
    entries.forEach(entry => body.row[entry.columnName] = entry.newValue);

    const [response, err] = await goStyle(axios({
      url: '/api/v0/db/tables/' + this.keyEntry.tableName,
      method: 'POST',
      data: body,
    }));

    this.saving = false;
    if (err || !response) {
      return console.error('saving error', err);
    }

    const newKey = response.data.row.ID;
    eventBus.emit('key-saved', {
      oldKey,
      newKey,
      table: this.keyEntry.tableName,
      tableOwner: this.keyData.owner,
      description: descriptionEntry ? descriptionEntry.newValue : newKey,
      autoQueueLevels,
    });

    store.commit.editor('changeKeyPath', {position: this.keyIndex, entry: {key: newKey}, splice: false});
  }

  private async validate() {
    this.validating = true;
    this.validationReport = null;
    const allRows = this.allRenderRows();
    const getvalue = key => {
      const row = allRows.find(r => r.columnName === key);
      return row ? row.newValue : '';
    };

    const body = {
      hltKey: getvalue('HLT_KEY'),
      trgKey: getvalue('L1_TRG_CONF_KEY'),
      rsKey: getvalue('L1_TRG_RS_KEY'),
    };

    const [response, err] = await goStyle(axios({
      url: `/api/v0/db/validateKeys`,
      method: 'POST',
      data: body,
      errorReporting: 'nonblocking',
    }));

    this.validating = false;
    if (err) {
      this.validationReport = {
        status: 'failed',
        reason: err,
      };
    } else {
      this.validationReport = response.data;
    }

  }

  private onDuplicate(data) {
    const allRows = this.allRenderRows();
    const m = allRows.find(r => r.columnName === this.keyData.mode_column);
    if (m) {
      m.newValue = data.mode;
    }
    const d = allRows.find(r => r.columnName === 'DESCRIPTION');
    if (d) {
      d.newValue = data.description;
    }
    this.duplicateMode = false;
  }
}
</script>

<style scoped lang='scss'>
[row-editor] {
  display: flex;
  flex-direction: row;
  height: 100%;
  &[clob] {
    flex: 1;
  }

  [primary] {
    min-width: 400px;
    [toolbar] {
      display: flex;
      flex-direction: row;
      align-items: center;

      .md-button {
        &.md-raised {
          color: white;
          @include md-theme-property(background, accent);
          &[red] {
            background: md-get-palette-color(red, 900);
          }
          &[disabled][disabled] {
            background: rgba(255,255,255,.3);
            color: md-get-palette-color(grey, 800);
          }
        }
        &[disabled] {
          color: rgba(255,255,255,.3);
        }

        .md-icon {
          margin-left: 8px;
        }
      }
    }

    [splitter] {
      display: flex;
      flex-direction: row;
      align-items: center;
    }

    .md-card {
      margin: 10px;

      &[error] {
        background: md-get-palette-color(red, A100);
      }
      &[warning] {
        background: md-get-palette-color(orange, A100);
      }
      &[success] {
        background: md-get-palette-color(green, 100);
      }

      .md-card-header {

        p {
          display: flex;
          flex-direction: row;
          align-items: center;
          margin: 0;
          .md-icon {
            margin: 5px;
          }
        }
      }

      .md-card-actions {
        padding-top: 0;
      }
    }

    [summary] {
      display: flex;
      flex-direction: column;
      margin: 10px;
      p {
        display: flex;
        flex-direction: row;
        margin: 0 10px;
        padding: 10px;
        align-items: center;

        &[edited] {
          background: md-get-palette-color(orange, 200);
        }
      }

      .meta-content-enter-active, .meta-content-leave-active {
        transition: all .1s ease-in-out;
      }
      .meta-content-enter, .meta-content-leave-to {
        transform: translateY(-10px);
        opacity: 0;
      }
    }
  }
}
</style>
<style lang="scss">
[row-editor] {
  [primary] {
    [toolbar] {
      .md-icon-button {
        &[disabled] {
          .md-icon.md-icon.md-icon svg {
            fill: rgba(255,255,255,.3);
          }
        }
      }
      .md-button {
        .md-button-content {
          display: flex;
          flex-direction: row;
          align-items: center;
        }
      }
    }
  }


  .md-card {
    &[success] {
      .md-icon {
        svg {
          fill: md-get-palette-color(green, 600);
        }
      }
    }
    &[error] {
      .md-icon {
        svg {
          fill: md-get-palette-color(red, 600);
        }
      }
    }
  }
}
</style>
